//Dynamic HUD lua coded by DirkTheHusky
//Original coding by Kart Krew
//Mini-map and position assist from Jade Space Rabbit
//Graphic drawing for position numbers coded by Bloops
//

/*local defaultxpos = 320
local defaultypos = 200*/
local timeflags = V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS	

local loaded = false

rawset(_G, "dyn_enabled", true)
rawset(_G, "dyn_positions", true)
rawset(_G, "dyn_gameinfo", true)
rawset(_G, "dyn_time", true)
rawset(_G, "dyn_speed", true)
rawset(_G, "dyn_minimap", true)
rawset(_G, "dyn_roulette", true)

local commands = {"dynamics", "dh_positions", "dh_time", "dh_gameinfo", "dh_speedometer", "dh_minimap", "dh_roulette"}
local filepath = 'client/DynamicHUD.cfg'

local function writeFile(p)
    if io and p == consoleplayer then
        local vars = {dyn_enabled, dyn_positions, dyn_time, dyn_gameinfo, dyn_speed, dyn_minimap, dyn_roulette}
        local file = io.open(filepath, "w+")
        local txt = ""
        for i = 1, #vars do
            local varToAdd = ""
            if vars[i] == true then
				varToAdd = "true"
            elseif vars[i] == false then
                varToAdd = "false"
            else
                varToAdd = tostring(vars[i])
            end
            txt = txt..varToAdd..'\n'
        end
        file:write(txt)
        file:close()
    end
end

local function readFile(p)
    if io and p == consoleplayer then
        local file = io.open(filepath, 'r')
        if file then
            local count = 1
            for line in file:lines() do
                COM_BufInsertText(p, commands[count]..' '..line..' yes')
                count = $ + 1
            end
        end
    end
end

rawset(_G, "dyn_setup", function(player, arg, suppress)
    if player == consoleplayer
        if arg == "on" or arg == "1" or arg == "true"
            if not (suppress == 'yes') then
                CONS_Printf(player, "Dynamic HUD on. Customize your game!")
                S_StartSound(nil, sfx_s243, player)
            end
            dyn_enabled = true
            writeFile(player)
        elseif arg == "off" or arg == "0" or arg == "false"
            if not (suppress == 'yes') then
                CONS_Printf(player, "Dynamic HUD off. Reverting back to default HUD.")
                S_StartSound(nil, sfx_s231, player)
            end
            dyn_enabled = false
            writeFile(player)
        else
            local onoff = dyn_enabled and 'on.' or 'off.'
            CONS_Printf(player, "Draws the same HUD with extra features. Dynamic HUD is "+onoff)
        end
    else
        print("This command can only be used in a level.")
    end
end)

COM_AddCommand("dynamics", dyn_setup)

COM_AddCommand("dh_positions", function(player, arg, suppress)
	if arg == "on" or arg == "1" or arg == "true"
		if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "Dynamic Positions on.")
			end
			dyn_positions = true
			writeFile(player)
		end
	 elseif arg == "off" or arg == "0" or arg == "false"
        if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "Dynamic Positions off.")
			end
			dyn_positions = false
			writeFile(player)
        end
    elseif player == consoleplayer
        local onoff = "on."
        if dyn_positions == false
            onoff = "off."
        end
        print("Dynamic Positions is "+onoff)
    end
end)

COM_AddCommand("dh_time", function(player, arg, suppress)
	if arg == "on" or arg == "1" or arg == "true"
		if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "Dynamic Time Stamp on.")
			end
			dyn_time = true
			writeFile(player)
		end
	 elseif arg == "off" or arg == "0" or arg == "false"
        if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "Dynamic Time Stamp off.")
			end
			dyn_time = false
			writeFile(player)
        end
    elseif player == consoleplayer
        local onoff = "on."
        if dyn_time == false
            onoff = "off."
        end
        print("Dynamic Time Stamp is "+onoff)
    end
end)

COM_AddCommand("dh_gameinfo", function(player, arg, suppress)
	if arg == "on" or arg == "1" or arg == "true"
		if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "Dynamic Game Info on.")
			end
			dyn_gameinfo = true
			writeFile(player)
		end
	 elseif arg == "off" or arg == "0" or arg == "false"
        if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "Dynamic Game Info off.")
			end
			dyn_gameinfo = false
			writeFile(player)
        end
    elseif player == consoleplayer
        local onoff = "on."
        if dyn_gameinfo == false
            onoff = "off."
        end
        print("Dynamic Game Info is "+onoff)
    end
end)

COM_AddCommand("dh_speedometer", function(player, arg, suppress)
	if arg == "on" or arg == "1" or arg == "true"
		if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "Dynamic Speedometer on.")
			end
			dyn_speed = true
			writeFile(player)
		end
	 elseif arg == "off" or arg == "0" or arg == "false"
        if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "Dynamic Speedometer off.")
			end
			dyn_speed = false
			writeFile(player)
        end
    elseif player == consoleplayer
        local onoff = "on."
        if dyn_speed == false
            onoff = "off."
        end
        print("Dynamic Speedometer is "+onoff)
    end
end)

COM_AddCommand("dh_minimap", function(player, arg, suppress)
	if arg == "on" or arg == "1" or arg == "true"
		if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "Dynamic Mini Map on.")
			end
			dyn_minimap = true
			writeFile(player)
		end
	 elseif arg == "off" or arg == "0" or arg == "false"
        if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "Dynamic Mini Map off.")
			end
			dyn_minimap = false
			writeFile(player)
        end
    elseif player == consoleplayer
        local onoff = "on."
        if dyn_minimap == false
            onoff = "off."
        end
        print("Dynamic Mini Map is "+onoff)
    end
end)

COM_AddCommand("dh_roulette", function(player, arg, suppress)
	if arg == "on" or arg == "1" or arg == "true"
		if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "Dynamic Roulette on.")
			end
			dyn_roulette = true
			writeFile(player)
		end
	 elseif arg == "off" or arg == "0" or arg == "false"
        if player == consoleplayer
			if not (suppress == 'yes') then
				CONS_Printf(player, "Dynamic Roulette off.")
			end
			dyn_roulette = false
			writeFile(player)
        end
    elseif player == consoleplayer
        local onoff = "on."
        if dyn_roulette == false
            onoff = "off."
        end
        print("Dynamic Roulette is "+onoff)
    end
end)

freeslot(
	"sfx_buwomp"
)

addHook("ThinkFrame", do
	for p in players.iterate do	
		-- Nil factors --
		----------------------------
		if p.huddisplay == nil
			p.huddisplay = 0
		end
		
		if p.displayscroll == nil
			p.displayscroll = 0
		end
			
		if p.itemdisscroll == nil
			p.itemdisscroll = 0
		end
			
		if p.itemdrawtime == nil
			p.itemdrawtime = 0
		end
		----------------------------
			
		-- Timer tables --
			
		-- Base HUD Displays --
		----------------------------
		if p.realtime == 0
			p.huddisplay = 0
		elseif p.realtime > 0
			p.huddisplay = $+1
		end
				
		if not p.exiting
			if splitscreen <= 2
				if p.huddisplay < TICRATE*2
					p.displayscroll = 148
				else
					p.displayscroll = max($-16,0)
				end
			else
				if p.huddisplay < TICRATE*2
					p.displayscroll = 230
				else
					p.displayscroll = max($-16,0)
				end
			end
		end
				
		if p.realtime > 0
			if p.exiting > 0 and p.exiting <= TICRATE/2
				if splitscreen >= 2
					p.displayscroll = min($+16,230)
					p.itemdisscroll = min($+16,60)
				else
					p.displayscroll = min($+16,148)
					p.itemdisscroll = min($+16,60)
				end
			end
		end	
		----------------------------
		-- Item HUD --
		----------------------------
		if p.kartstuff[k_itemroulette] or p.kartstuff[k_itemtype]
		or p.kartstuff[k_stolentimer] > 0
		or p.kartstuff[k_stealingtimer] > 0
		or p.kartstuff[k_eggmanexplode] > 1
		or p.kartstuff[k_rocketsneakertimer] > 1
		or p.kartstuff[k_growshrinktimer] > 0
		or p.kartstuff[k_sadtimer] > 0
			p.itemdisscroll = max($-10,0)
		elseif p.kartstuff[k_itemtype] == 0
			p.itemdisscroll = 60
		end
		----------------------------
		if p.kartstuff[k_sadtimer] > 0
			if p.kartstuff[k_sadtimer] == (TICRATE/2)-1
				S_StartSound(p.mo, sfx_buwomp)
			end
		end
		----------------------------
		-- Lap time --
		----------------------------
		if p.laptimer == nil
			p.laptimer = 0
		end
		if p.lapsavetime == nil or p.spectator
			p.lapsavetime = 0
		end
		
		if p.realtime > 0
			p.laptimer = $+1
			p.lapsaved = false
			if not p.kartstuff[k_lapanimation]
				p.lapsavetime = $+1
			end
		else
			p.laptimer = 0
			p.lapsavetime = 0
			p.lapsaved = false
		end
		if p.kartstuff[k_lapanimation]
			if p.kartstuff[k_lapanimation] == 80
				p.lapsavetime = p.laptimer
				p.laptimer = 0
			end
			p.lapsaved = true
		else
			p.lapsaved = false
			p.lapsavetime = 0
		end
	end
end)

addHook("PlayerJoin", do
	for p in players.iterate do
		if p.lapsavetime == nil
			p.lapsavetime = 0
		end
		p.laptimer = 0
		p.lapsaved = false
	end
end)

// Borrowed some lua from some other project that I was working on. Made by bloops

local function drawAtDivider(v, div, x, y, patch, flags, color)
	v.drawScaled(x*div, y*div, div, patch, flags, color)
end

local function drawPositionPatches(v, div, x, y, basePatch, number, gap, rightAligned, flags, filler, colormap)
	number = filler and (string.rep('0',filler-tostring($):len())..tostring($)) or tostring($)
	rightAligned = $ and -1 or 1
	if (rightAligned-1)
		for i = number:len(), 1, -1
			drawAtDivider(v, div, x+(gap*(i-1))-((number:len()-1)*gap), y, v.cachePatch(basePatch..number:sub(i,i)), flags, colormap)
		end
	else
		for i = 1, number:len()
			drawAtDivider(v, div, x+(gap*(i-1)), y, v.cachePatch(basePatch..number:sub(i,i)), flags, colormap)
		end
	end
end

local function draw_newpositions(v, stplyr)
	if not G_RaceGametype()
	or loaded == false
		return
	end

	if dyn_enabled == true
		hud.disable("position")
		
		local posflags = V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_40TRANS
			
		local color = v.getColormap(TC_DEFAULT, stplyr.color)
		local checklaps = CV_FindVar("numlaps")
		local icon = "K_POSC0"
		
		local posx //Draw at x coordinates
		local posy //Draw at y coordinates
		local picx //Draw banner at x coordinates
		local picy //Draw banner at y coordinates
		
		local scale
		local trans = 0
		
		local align
		
		local postable
		
		local actualposx //Draw timer and x combined
		local actualpicx //Draw timer and x combined
		
		if splitscreen
			scale = FRACUNIT/2
			for player in displayplayers.iterate
				if player.splitscreenindex == 0
					trans = V_40TRANS
				end
			end

			//2P Splitscreen
			if splitscreen == 1
				if stplyr == displayplayers[0]
					posx = 622
					posy = 60

					actualposx = posx+stplyr.displayscroll
					posflags = V_SNAPTORIGHT|V_SNAPTOTOP|trans
				else
					posx = 622
					posy = 384

					actualposx = posx+stplyr.displayscroll
					posflags = V_SNAPTORIGHT|V_SNAPTOBOTTOM|trans
				end
			//3P and 4P Splitscreen
			elseif splitscreen >= 2
				if stplyr ==  displayplayers[0]
					posx = 48
					posy = 168

					actualposx = posx-stplyr.displayscroll
					posflags = V_SNAPTOLEFT|V_SNAPTOTOP|trans
				elseif stplyr ==  displayplayers[1]
					posx = 632
					posy = 168

					actualposx = posx+stplyr.displayscroll
					posflags = V_SNAPTORIGHT|V_SNAPTOTOP|trans
				elseif stplyr == displayplayers[2]
					posx = 48
					posy = 368

					actualposx = posx-stplyr.displayscroll
					posflags = V_SNAPTOLEFT|V_SNAPTOBOTTOM|trans
				else
					posx = 632
					posy = 368

					actualposx = posx+stplyr.displayscroll
					posflags = V_SNAPTORIGHT|V_SNAPTOBOTTOM|trans
				end
			end
		else
			posx = 310
			posy = 194
			
			scale = FRACUNIT
		
			actualposx = posx+stplyr.displayscroll
			posflags = V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_40TRANS
		end
		
		local lowestplase = 0

		if(stplyr.valid and not stplyr.spectator)then
			local count=0
			local iter =0
			while(count<2 and iter < #players)do --an optimization is to do this in THink frame and use the value in this
				if(players[iter] ) then
					if( players[iter].valid and not players[iter].spectator) then
						count=$+1
					end
				else
					iter=#players
				end
				iter=$+1
			end
			
			if(count>=2)then
				if stplyr.kartstuff[k_positiondelay] or stplyr.exiting
					scale = $*2
					if splitscreen == 1
						if stplyr ==displayplayers[0]
							--scale = FRACUNIT
							posx = 311
							posy = 56
							
							actualposx = posx+stplyr.displayscroll
						else
							--scale = FRACUNIT
							posx = 311
							posy = 192
							
							actualposx = posx+stplyr.displayscroll
						end
					elseif splitscreen >= 2
						if stplyr==displayplayers[0]
							posx = 46
							posy = 84

							actualposx = posx-stplyr.displayscroll
						elseif stplyr ==displayplayers[1]
							posx = 316
							posy = 84

							actualposx = posx+stplyr.displayscroll
						elseif stplyr==displayplayers[2]
							posx = 46
							posy = 184

							actualposx = posx-stplyr.displayscroll
						else
							posx = 316
							posy = 184

							actualposx = posx+stplyr.displayscroll
						end
					else
						posx = 156
						posy = 98
						
						actualposx = posx+stplyr.displayscroll
					end
				end
			
				if stplyr.exiting and stplyr.kartstuff[k_position] == 1
					color = SKINCOLOR_SALMON + (leveltime/3 % (101-16))
				elseif stplyr.laps+1 >= checklaps.value or stplyr.exiting
					if K_IsPlayerLosing(stplyr) and (stplyr.kartstuff[k_position] > lowestplase)
						postable = ({
							SKINCOLOR_SALMON,
							SKINCOLOR_LEMONADE,
						})[(leveltime/2 % 3)]
						
						if postable == nil
							postable = SKINCOLOR_RASPBERRY
						end
						
						color = postable
					else
						postable = ({
							SKINCOLOR_JAWZ,
							SKINCOLOR_CYAN,
						})[(leveltime/4 % 3)]
							
						if postable == nil
							postable = SKINCOLOR_PERIWINKLE
						end
							
						color = postable
					end
				else
					if not splitscreen
						color = SKINCOLOR_WSUPER1
					else
						color = stplyr.skincolor
					end
				end	
			
				--print("WE ARE RACING, BRING THE POSITION")--Put drawing code here
				drawPositionPatches(v, scale, actualposx, posy, icon, stplyr.kartstuff[k_position], 45, true, posflags, 0, v.getColormap(TC_DEFAULT, color))
			end
		end
	end
end

local function draw_newtime(v, stplyr)
	if not dyn_enabled
	or loaded == false
	or splitscreen //Don't draw 
		return
	end
	if dyn_time == true
		--custom_drawbase(v, stplyr)
		
		v.hudminutes = stplyr.realtime/(60*TICRATE)
		v.hudseconds = G_TicsToSeconds(stplyr.realtime)
		v.hudmillisecs = G_TicsToCentiseconds(stplyr.realtime)
		
		local color = v.getColormap(TC_DEFAULT, stplyr.skincolor)
		
		local checklaps = CV_FindVar("numlaps")
					
		v.draw(172+stplyr.displayscroll, 9, v.cachePatch("K_SCTIMW"), timeflags, color)
		
		if stplyr.lapsaved == false or stplyr.spectator
			if (v.hudminutes < 100)
				--v.drawKartString(244+v.displayscroll, 12, "00'00\''00", timeflags)
					
				// Minutes
				if (v.hudminutes < 10)
					v.drawKartString(205+stplyr.displayscroll, 12, "0", timeflags)
					v.drawKartString(217+stplyr.displayscroll, 12, v.hudminutes, timeflags)
				else
					v.drawKartString(205+stplyr.displayscroll, 12, v.hudminutes, timeflags)
				end
				v.drawKartString(229+stplyr.displayscroll, 12, "'", timeflags)
				
				// Seconds
				if (v.hudseconds < 10)
					v.drawKartString(241+stplyr.displayscroll, 12, "0", timeflags)
					v.drawKartString(253+stplyr.displayscroll, 12, v.hudseconds, timeflags)
				else
					v.drawKartString(241+stplyr.displayscroll, 12, v.hudseconds, timeflags)
				end
				v.drawKartString(265+stplyr.displayscroll, 12, '"', timeflags)
				
				//Centiseconds
				if (v.hudmillisecs < 10)
					v.drawKartString(277+stplyr.displayscroll, 12, "0", timeflags)
					v.drawKartString(289+stplyr.displayscroll, 12, v.hudmillisecs, timeflags)
				else
					v.drawKartString(277+stplyr.displayscroll, 12, v.hudmillisecs, timeflags)
				end
			elseif (stplyr.realtime % TICRATE)
				v.drawKartString(205+stplyr.displayscroll, 12, "99'59"..'\"'.."99", timeflags)
			end
		else
			//We set up the lap time when we actually finish a lap/segment
			v.recminutes = stplyr.lapsavetime/(60*TICRATE)
			v.recseconds = G_TicsToSeconds(stplyr.lapsavetime)
			v.recmillisecs = G_TicsToCentiseconds(stplyr.lapsavetime)
		
			if (leveltime % 16 <= 8)
				if (v.recminutes < 100)
					--v.drawKartString(244+v.displayscroll, 12, "00'00\''00", timeflags)
							
					// Minutes
					if (v.recminutes < 10)
						v.drawKartString(205+stplyr.displayscroll, 12, "0", timeflags)
						v.drawKartString(217+stplyr.displayscroll, 12, v.recminutes, timeflags)
					else
						v.drawKartString(205+stplyr.displayscroll, 12, v.recminutes, timeflags)
					end
					v.drawKartString(229+stplyr.displayscroll, 12, "'", timeflags)
						
					// Seconds
					if (v.recseconds < 10)
						v.drawKartString(241+stplyr.displayscroll, 12, "0", timeflags)
						v.drawKartString(253+stplyr.displayscroll, 12, v.recseconds, timeflags)
					else
						v.drawKartString(241+stplyr.displayscroll, 12, v.recseconds, timeflags)
					end
					v.drawKartString(265+stplyr.displayscroll, 12, '"', timeflags)
						
					//Centiseconds
					if (v.recmillisecs < 10)
						v.drawKartString(277+stplyr.displayscroll, 12, "0", timeflags)
						v.drawKartString(289+stplyr.displayscroll, 12, v.recmillisecs, timeflags)
					else
						v.drawKartString(277+stplyr.displayscroll, 12, v.recmillisecs, timeflags)
					end
				end
			else
				v.drawKartString(205+stplyr.displayscroll, 12, "", timeflags)
			end
		end
	else
		return
	end
end

local function draw_newgametype(v, stplyr)
	if stplyr.spectator
	or loaded == false
	or not dyn_gameinfo
		return
	end
	local lapflags = V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS	
		
	local checklaps = CV_FindVar("numlaps")
	local bumpers = CV_FindVar("kartbumpers")
		
	local color = v.getColormap(TC_DEFAULT, stplyr.skincolor)
	
	local posx //Draw at x coordinates
	local posy //Draw at y coordinates
	
	local icon //Draw banner for lap or section race
	
	local picx //Draw banner at x coordinates
	local picy //Draw banner at y coordinates
	
	local align
	
	local actualposx //Draw timer and x combined
	local actualpicx //Draw timer and x combined
	
	//Let's set our local variables according to the splitscreen, shall we?
	if dyn_enabled == true
	
		if splitscreen
			//2P Splitscreen
			if splitscreen == 1
				if stplyr.splitscreenindex == 0
					if G_RaceGametype()
						posx = 42
						actualposx = posx-stplyr.displayscroll
					else
						posx = 56
						actualposx = posx-stplyr.displayscroll
					end
					posy = 79
					picx = 9
					picy = 76
					actualpicx = picx-stplyr.displayscroll
					lapflags = V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS
				elseif stplyr.splitscreenindex == 1
					if G_RaceGametype()
						posx = 42
						actualposx = posx-stplyr.displayscroll
					else
						posx = 56
						actualposx = posx-stplyr.displayscroll
					end
					posy = 179
					picx = 9
					picy = 176
					actualpicx = picx-stplyr.displayscroll
					lapflags = V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS
				end
			//3P and 4P Splitscreen
			elseif splitscreen >= 2
				if stplyr.splitscreenindex == 0
					if G_RaceGametype()
						posx = 16
						posy = 88
						picx = 3
						picy = 87
					else
						posx = 40
						posy = 88
						picx = 3
						picy = 86
					end
					actualposx = posx-stplyr.displayscroll
					actualpicx = picx-stplyr.displayscroll
					lapflags = V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS
					align = "left"
				elseif stplyr.splitscreenindex == 1
					if G_RaceGametype()
						posx = 293
						posy = 88
						picx = 280
						picy = 87
					else
						posx = 317
						posy = 88
						picx = 280
						picy = 86
					end
					actualposx = posx+stplyr.displayscroll
					actualpicx = picx+stplyr.displayscroll
					lapflags = V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS
					align = "right"
				elseif stplyr.splitscreenindex == 2
					if G_RaceGametype()
						posx = 16
						posy = 188
						picx = 3
						picy = 187
					else
						posx = 40
						posy = 188
						picx = 3
						picy = 186
					end
					actualposx = posx-stplyr.displayscroll
					actualpicx = picx-stplyr.displayscroll
					lapflags = V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS
					align = "left"
				elseif stplyr.splitscreenindex == 3
					if G_RaceGametype()
						posx = 293
						posy = 188
						picx = 280
						picy = 187
					else
						posx = 317
						posy = 188
						picx = 280
						picy = 186
					end
					actualposx = posx+stplyr.displayscroll
					actualpicx = picx+stplyr.displayscroll
					lapflags = V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS
					align = "right"
				end
			end
		else
			if G_RaceGametype()
				posx = 42
				actualposx = posx-stplyr.displayscroll
			else
				posx = 56
				actualposx = posx-stplyr.displayscroll
			end
			posy = 174
			picx = 9
			picy = 171
			actualpicx = picx-stplyr.displayscroll
			lapflags = V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS
		end
		
		
		/*if splitscreen <= 1
			v.draw(actualpicx, picy, icon, lapflags, color)
		else
			v.draw(actualpicx, picy, v.cachePatch("K_SPTLAP"), lapflags, color)
		end*/
		
		//Draw the HUD in
		-- Race --
		if G_RaceGametype()
			//If we're playing alone or in 2P Split-screen
			if splitscreen <= 1
				if mapheaderinfo[gamemap].levelflags & LF_SECTIONRACE
					icon = v.cachePatch("K_SCSECT")
				else
					icon = v.cachePatch("K_SCLAPSW")
				end
			
				v.draw(actualpicx, picy, icon, lapflags, color)
			
				if (stplyr.exiting)
					v.drawKartString(actualposx, posy, "FIN", lapflags)
					--V_DrawKartString(LAPS_X+33, LAPS_Y+3, V_HUDTRANS|splitflags, "FIN");
				else
					if stplyr.laps >= 9
						v.drawKartString(actualposx, posy, "  ".."/"..checklaps.value, lapflags)
						if stplyr.kartstuff[k_lapanimation] > 1
							if (leveltime % 16 <= 8)
								v.drawKartString(actualposx, posy, stplyr.laps+1, lapflags)
							end
						elseif stplyr.kartstuff[k_lapanimation] == 0
							v.drawKartString(actualposx, posy, stplyr.laps+1, lapflags)
						end
					else
						v.drawKartString(actualposx, posy, " ".."/"..checklaps.value, lapflags)
						if stplyr.kartstuff[k_lapanimation] > 1
							if (leveltime % 16 <= 8)
								v.drawKartString(actualposx, posy, stplyr.laps+1, lapflags)
							end
						elseif stplyr.kartstuff[k_lapanimation] == 0
							v.drawKartString(actualposx, posy, stplyr.laps+1, lapflags)
						end
					end
				end
				//If we're playing in 3P or 4P Splitscreen
			else
				if mapheaderinfo[gamemap].levelflags & LF_SECTIONRACE
					icon = v.cachePatch("K_SPTSEC")
				else
					icon = v.cachePatch("K_SPTLAP")
				end
				
				local move = 0
				
				if stplyr.splitscreenindex == 1 or stplyr.splitscreenindex == 3
					if stplyr.laps >= 9
						move = -15
					else
						move = 0
					end
				end
				
				v.draw(actualpicx+move, picy, icon, lapflags, color)
			
				if (stplyr.exiting)
					v.drawString(actualposx, posy, "FIN", lapflags)
					--V_DrawKartString(LAPS_X+33, LAPS_Y+3, V_HUDTRANS|splitflags, "FIN");
				else
					if stplyr.laps >= 9
						v.drawString(actualposx+3+move, posy, "   ".."/"..checklaps.value+27, lapflags)
						if stplyr.kartstuff[k_lapanimation] > 1
							if (leveltime % 16 <= 8)
								v.drawString(actualposx+move, posy, stplyr.laps+10, lapflags)
							end
						elseif stplyr.kartstuff[k_lapanimation] == 0
							v.drawString(actualposx+move, posy, stplyr.laps+10, lapflags)
						end
					else
						v.drawString(actualposx+3, posy, " ".."/"..checklaps.value, lapflags)
						if stplyr.kartstuff[k_lapanimation] > 1
							if (leveltime % 16 <= 8)
								v.drawString(actualposx, posy, stplyr.laps+1, lapflags)
							end
						elseif stplyr.kartstuff[k_lapanimation] == 0
							v.drawString(actualposx, posy, stplyr.laps+1, lapflags)
						end
					end
				end
			end
		-- Battle --
		else
			if stplyr.kartstuff[k_comebacktimer] == 0 and stplyr.kartstuff[k_comebackmode] >= 0 and stplyr.kartstuff[k_comebackpoints] //Don't draw the HUD if we're preparing to make our come back karma
			or (stplyr.exiting) // Or if we finished the battle
				local move = 0
				
				if stplyr.splitscreenindex == 1 or stplyr.splitscreenindex == 3
					if stplyr.laps >= 0
						move = -15
					else
						move = 0
					end
				end
			
				if splitscreen <= 1
					if (stplyr.kartstuff[k_bumper] <= 0)
						icon = v.cachePatch("K_SCKARM")
						v.draw(actualpicx, picy, icon, lapflags, color)
						v.drawKartString(actualposx, posy, stplyr.kartstuff[k_comebackpoints].."/2", lapflags, "right")
					else
						icon = v.cachePatch("K_SCBALN")
						v.draw(actualpicx, picy, icon, lapflags, color)
						v.drawKartString(actualposx, posy, stplyr.kartstuff[k_bumper].."/"..bumpers.value, lapflags, "right")
					end
				//If we're playing in 3P or 4P Splitscreen
				else
					if (stplyr.kartstuff[k_bumper] <= 0)
						icon = v.cachePatch("K_SPTKRM")
						v.draw(actualpicx, picy, icon, lapflags, color)
						v.drawString(actualposx, posy, stplyr.kartstuff[k_comebackpoints].."/2", lapflags, "right")
					else
						icon = v.cachePatch("K_BLNICO")
						if stplyr.kartstuff[k_bumper] >= 10
							v.draw(actualpicx+move, picy, icon, lapflags, color)
							v.drawString(actualposx+move, posy, stplyr.kartstuff[k_bumper].."/"..bumpers.value, lapflags, "right")
						else
							v.draw(actualpicx, picy, icon, lapflags, color)
							v.drawString(actualposx, posy, stplyr.kartstuff[k_bumper].."/"..bumpers.value, lapflags, "right")
						end
					end
				end
			end
		end
	end
end

local function draw_newspeedometer(v, stplyr)
	if stplyr.spectator
	or loaded == false
	or splitscreen
	or not dyn_speed
	or (kvr_hud and kvr_hud.value)-- Kart VR support. Disables the speedometer if that mod's speedometer's HUD is on.
		return
	end
	
	if dyn_enabled == true
		--custom_drawbase(v, stplyr)
		
		local speed = CV_FindVar("kartdisplayspeed")
		local convSpeed
		local percent = 62914
		
		if speed.value == 1
			convSpeed = FixedDiv(FixedMul(stplyr.speed, 142371), mapheaderinfo[gamemap].mobj_scale)/FRACUNIT; // 2.172409058
			v.drawKartString(33-stplyr.displayscroll, 155, convSpeed.." km/h", V_SNAPTOLEFT|V_SNAPTOBOTTOM, "left")
		elseif speed.value == 2
			convSpeed = FixedDiv(FixedMul(stplyr.speed, 88465), mapheaderinfo[gamemap].mobj_scale)/FRACUNIT; // 2.172409058
			v.drawKartString(33-stplyr.displayscroll, 155, convSpeed.." mph", V_SNAPTOLEFT|V_SNAPTOBOTTOM, "left")
		elseif speed.value == 3
			convSpeed = FixedDiv(stplyr.speed, mapheaderinfo[gamemap].mobj_scale)/FRACUNIT; // 2.172409058
			v.drawKartString(33-stplyr.displayscroll, 155, convSpeed.." fu/t", V_SNAPTOLEFT|V_SNAPTOBOTTOM, "left")
		-- Moe Mansion-Galaxy support
		elseif speed.value == 4
			if stplyr.mo
				convSpeed = (FixedDiv(stplyr.speed, FixedMul(K_GetKartSpeed(stplyr, false), percent))*100>>FRACBITS)
				v.drawKartString(33-stplyr.displayscroll, 155, convSpeed.." p", V_SNAPTOLEFT|V_SNAPTOBOTTOM, "left")
			end
		end
	end
end

-- Originally written by me. Optimized by Jade Space Rabbit.
local function draw_newminimap(v, stplyr)
	if not dyn_minimap
	or loaded == false
		return
	end

	local x
	local y
	local flags
	local table
	
	local realx
	local scale
	
	local addx = stplyr.displayscroll*(FRACUNIT*256)
	local playerpos
	
	table = ({
		V_90TRANS,
		V_80TRANS,
		V_70TRANS,
		V_60TRANS,
		V_50TRANS,
		V_40TRANS,
		V_30TRANS,
		V_20TRANS,
		V_10TRANS,
	})[CV_FindVar("kartminimap").value]
	
	if CV_FindVar("kartminimap") == 0
		return
	end	
	
	if encoremode
		flags = V_SNAPTORIGHT|table|V_FLIP
		--playerpos = stplyr.mo.x-addx
	else
		flags = V_SNAPTORIGHT|table
		--playerpos = stplyr.mo.x+addx
	end
	
	if dyn_enabled == true
		if splitscreen == 0
			x = 220
			y = 34
			if encoremode
				x = 320
				y = 34
			end
			realx = x+stplyr.displayscroll
		elseif splitscreen == 1
			x = 220
			y = 50
			if encoremode
				x = 320
				y = 50
			end
			
			realx = x+stplyr.displayscroll
		elseif splitscreen == 2
			x = 190
			y = 100
			if encoremode
				x = 290
				y = 100
			end
			realx = x+stplyr.displayscroll
		elseif splitscreen == 3
			x = 110
			y = 50
			if encoremode
				x = 210
				y = 50
			end
			realx = x+stplyr.displayscroll
		end
		
		--print(addx)
		
		local drawmap
		local mappatch = (G_BuildMapName(gamemap).."R")
		
		if not (v.patchExists(mappatch)) return end
		
		drawmap = v.cachePatch(mappatch, flags)
		--local mapadd = 300 - map_height
		
		// Only draw the mini-map once in Splitscreen
		if splitscreen
			if stplyr==displayplayers[0]
				v.draw(realx, y, drawmap, flags)
			end
		else
			v.draw(realx, y, drawmap, flags)
		end
		
		if stplyr.displayscroll > 0
			if addx < 0
				--print("values are too low!")
				return
			end
		end
		
		if stplyr.realtime > TICRATE
			
			scale = FRACUNIT
			
			if stplyr.splitscreenindex == 0 then
				for player in players.iterate
					local check = false
					if(player and player.valid and (not player.spectator)) then
						local fallback=0
							while(fallback<=splitscreen) do
								if displayplayers[fallback]==player then
									check=true
									fallback=7
								end
								fallback=$+1
							end
							
						if encoremode
							playerpos = player.mo.x-addx
						else
							playerpos = player.mo.x+addx
						end
							
						if player.kartstuff[k_growshrinktimer] > 0
							scale = FRACUNIT
						elseif player.kartstuff[k_growshrinktimer] < 0
							scale = FRACUNIT/2
						else
							scale = 3*FRACUNIT/4
						end
						
						
						if not check then
						
							local color  = v.getColormap(TC_DEFAULT, player.mo.color)
							v.drawOnMinimap(playerpos, player.mo.y, scale, v.cachePatch((skins[player.mo.skin].facemmap)), color, false)--This is transparent
						end
						if G_RaceGametype() and player.kartstuff[k_position] == spbplace
						or G_BattleGametype() and K_IsPlayerWanted(player) then
							v.drawOnMinimap(playerpos, player.mo.y, FRACUNIT, v.cachePatch("MMAPWANT"), color, false)
						end
							--Hacker magic.
					end
				end
					
				for dplayer in displayplayers.iterate
					if(dplayer and dplayer.valid and (not dplayer.spectator)) then
						if encoremode
							playerpos = dplayer.mo.x-addx
						else
							playerpos = dplayer.mo.x+addx
						end
					
						if dplayer.kartstuff[k_growshrinktimer] > 0
							scale = 5*FRACUNIT/4
						elseif dplayer.kartstuff[k_growshrinktimer] < 0
							scale = 3*FRACUNIT/4
						else
							scale = FRACUNIT
						end
					
						local color  = v.getColormap(TC_DEFAULT, dplayer.mo.color)
						v.drawOnMinimap(playerpos, dplayer.mo.y, scale, v.cachePatch((skins[dplayer.mo.skin].facemmap)), color, false)--This is transparent
						if G_RaceGametype() and dplayer.kartstuff[k_position] == spbplace
						or G_BattleGametype() and K_IsPlayerWanted(dplayer) then
								v.drawOnMinimap(playerpos, dplayer.mo.y, FRACUNIT, v.cachePatch("MMAPWANT"), color, false)
						end
					end
				end
			end
        end
    end
end

local function draw_newroulette(v, stplyr)
	if not dyn_roulette
	or loaded == false
	or stplyr.spectator
	or (JUICEBOX and JUICEBOX.value) -- Juicebox
	or xItemLib -- xItemLib
		return
	end
	
	local itemflags
	local mulflip
	
	-- General --
	local posx //Draw at x coordinates
	local posy //Draw at y coordinates
	
	-- Where to draw the HUD --
	local picx //Draw icon at x coordinates
	local picy //Draw icon at y coordinates
	
	-- Item and borders --
	local actualposx //Draw timer and x combined
	local actualpicx //Draw icon and x combined
	
	-- Item multiplier --
	local multix
	local multiy
	
	local multistringx
	local multistringy
	
	-- Item bar --
	local borderx
	local bordery
	
	local fillx
	local filly
	
	local barx
	local bary
	
	-- Fake Egg Numbers --
	
	local fakex
	local fakey
	
	-- Actual X positions --
	local realmulx //X
	local realmulstx //Mult String
	local realborx //Bar border
	local realfilx //Bar fill
	local realbarx //Bar shade
	local realfakex //Fake numbers
	-------------------------------------
		
	local nothing = v.cachePatch("K_TRNULL") //Nothing
	
	local border //Border
	local itemstring //Item string
	
	local bordercolor = SKINCOLOR_NONE //Color of the border
	local hudcolor = SKINCOLOR_NONE //What color to colorize the items
	local colormap = TC_RAINBOW //Colormap 
	local item //What item we have
	local minimal = ((stplyr.kartstuff[k_itemtype] == KITEM_ORBINAUT and not (splitscreen > 1)) and 5 or 2) //Number on when to draw the multiplier
	local orbi //Orbinaut icons for splitscreen
		
	local table //Item table
	local blink //HUD blink
	local colorborder //Color in the border
	local coloritem //Color in the items
		
	local itemtime = 8*TICRATE //How long the item lasts
	local bar //What item we have that requires the bar hud?
	local barl = (splitscreen > 1 and 12 or 26) //length for the bar inside.
	local maxl //The length for said bar.
		
	//Let's set our local variables according to the splitscreen, shall we?
	if dyn_enabled == true
		if splitscreen
			//2P Splitscreen
			if splitscreen == 1
				itemstring = "K_IT"
				if stplyr.splitscreenindex == 0
					posx = 5
					posy = 4
					picx = 5
					picy = 4
					
					multix = 33
					multiy = 45
					
					multistringx = 43
					multistringy = 40
					
					borderx = 16
					bordery = 39
					
					fillx = 17
					filly = 40
					
					barx = 18
					bary = 41
					
					fakex = 22
					fakey = 17
					
					actualposx = posx-stplyr.itemdisscroll
					actualpicx = picx-stplyr.itemdisscroll
					
					realmulx = multix-stplyr.itemdisscroll
					realmulstx = multistringx-stplyr.itemdisscroll
					realborx = borderx-stplyr.itemdisscroll
					realfilx = fillx-stplyr.itemdisscroll
					realbarx = barx-stplyr.itemdisscroll
					realfakex = fakex-stplyr.itemdisscroll
					
					itemflags = V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS
					mulflip = V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS
				elseif stplyr.splitscreenindex == 1
					/*posx = 5
					posy = 105
					picx = 5
					picy = 105
					actualposx = posx-stplyr.itemdisscroll
					actualpicx = picx-stplyr.itemdisscroll
					itemflags = V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS*/
					posx = 5
					posy = 104
					picx = 5
					picy = 104
					
					multix = 133
					multiy = 145
					
					multistringx = 143
					multistringy = 140
					
					borderx = 116
					bordery = 139
					
					fillx = 117
					filly = 140
					
					barx = 118
					bary = 141
					
					fakex = 122
					fakey = 117
					
					actualposx = posx-stplyr.itemdisscroll
					actualpicx = picx-stplyr.itemdisscroll
					
					realmulx = multix-stplyr.itemdisscroll
					realmulstx = multistringx-stplyr.itemdisscroll
					realborx = borderx-stplyr.itemdisscroll
					realfilx = fillx-stplyr.itemdisscroll
					realbarx = barx-stplyr.itemdisscroll
					realfakex = fakex-stplyr.itemdisscroll
					
					itemflags = V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS
					mulflip = V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS
				end
			//3P and 4P Splitscreen
			elseif splitscreen >= 2
				itemstring = "K_IS"
				if stplyr.splitscreenindex == 0
					posx = -9
					posy = -8
					picx = -9
					picy = -8
					
					multix = -9
					multiy = 20
					
					multistringx = 15
					multistringy = 23
					
					borderx = 8
					bordery = 19
					
					fillx = 8
					filly = 20
					
					barx = 9
					bary = 20
					
					fakex = 7
					fakey = 4
					
					actualposx = posx-stplyr.itemdisscroll
					actualpicx = picx-stplyr.itemdisscroll
					
					realmulx = multix-stplyr.itemdisscroll
					realmulstx = multistringx-stplyr.itemdisscroll
					realborx = borderx-stplyr.itemdisscroll
					realfilx = fillx-stplyr.itemdisscroll
					realbarx = barx-stplyr.itemdisscroll
					realfakex = fakex-stplyr.itemdisscroll
					
					itemflags = V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS
					mulflip = V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS
				elseif stplyr.splitscreenindex == 1
					posx = 281
					posy = -8
					picx = 281
					picy = -8
					
					multix = 329
					multiy = 20
					
					multistringx = 283
					multistringy = 23
					
					borderx = 298
					bordery = 19
					
					fillx = 298
					filly = 20
					
					barx = 299
					bary = 20
					
					fakex = 297
					fakey = 4
					
					actualposx = posx+stplyr.itemdisscroll
					actualpicx = picx+stplyr.itemdisscroll
					
					realmulx = multix+stplyr.itemdisscroll
					realmulstx = multistringx+stplyr.itemdisscroll
					realborx = borderx+stplyr.itemdisscroll
					realfilx = fillx+stplyr.itemdisscroll
					realbarx = barx+stplyr.itemdisscroll
					realfakex = fakex+stplyr.itemdisscroll
					
					itemflags = V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS
					mulflip = V_FLIP|V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS
				elseif stplyr.splitscreenindex == 2
					posx = -9
					posy = 92
					picx = -9
					picy = 92
					
					multix = -9
					multiy = 120
					
					multistringx = 15
					multistringy = 123
					
					borderx = 8
					bordery = 119
					
					fillx = 8
					filly = 120
					
					barx = 9
					bary = 120
					
					fakex = 7
					fakey = 104
					
					actualposx = posx-stplyr.itemdisscroll
					actualpicx = picx-stplyr.itemdisscroll
					
					realmulx = multix-stplyr.itemdisscroll
					realmulstx = multistringx-stplyr.itemdisscroll
					realborx = borderx-stplyr.itemdisscroll
					realfilx = fillx-stplyr.itemdisscroll
					realbarx = barx-stplyr.itemdisscroll
					realfakex = fakex-stplyr.itemdisscroll
					
					itemflags = V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS
					mulflip = V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS
				elseif stplyr.splitscreenindex == 3
					posx = 281
					posy = 92
					picx = 281
					picy = 92
					
					multix = 329
					multiy = 120
					
					multistringx = 283
					multistringy = 123
					
					borderx = 298
					bordery = 119
					
					fillx = 298
					filly = 120
					
					barx = 299
					bary = 120
					
					fakex = 297
					fakey = 104
					
					actualposx = posx+stplyr.itemdisscroll
					actualpicx = picx+stplyr.itemdisscroll
					
					realmulx = multix+stplyr.itemdisscroll
					realmulstx = multistringx+stplyr.itemdisscroll
					realborx = borderx+stplyr.itemdisscroll
					realfilx = fillx+stplyr.itemdisscroll
					realbarx = barx+stplyr.itemdisscroll
					realfakex = fakex+stplyr.itemdisscroll
					
					itemflags = V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS
					mulflip = V_FLIP|V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS
				end
			end
		else
		
			posx = 5
			posy = 5
			picx = 5
			picy = 5
			
			multix = 33
			multiy = 46
			
			multistringx = 43
			multistringy = 41
			
			borderx = 16
			bordery = 40
			
			fillx = 17
			filly = 41
			
			barx = 18
			bary = 42
			
			fakex = 23
			fakey = 18
			
			actualposx = posx-stplyr.itemdisscroll
			actualpicx = picx-stplyr.itemdisscroll
			
			realmulx = multix-stplyr.itemdisscroll
			realmulstx = multistringx-stplyr.itemdisscroll
			realborx = borderx-stplyr.itemdisscroll
			realfilx = fillx-stplyr.itemdisscroll
			realbarx = barx-stplyr.itemdisscroll
			realfakex = fakex-stplyr.itemdisscroll
			
			
			itemflags = V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS
			itemstring = "K_IT"
		end
			
		// What Item are we going to get?
			
		if (stplyr.kartstuff[k_itemroulette])
			if (stplyr.skincolor)
				hudcolor = stplyr.skincolor
			end
			
			orbi = ((splitscreen >= 2) and "ORBN" or "ORB4")
			
			table = ({
				v.cachePatch(itemstring.."SHOE"),
				v.cachePatch(itemstring.."BANA"),
				v.cachePatch(itemstring..orbi),
				v.cachePatch(itemstring.."MINE"),
				v.cachePatch(itemstring.."GROW"),
				v.cachePatch(itemstring.."HYUD"),
				v.cachePatch(itemstring.."RSHE"),
				v.cachePatch(itemstring.."JAWZ"),
				v.cachePatch(itemstring.."SPB"),
				v.cachePatch(itemstring.."SHRK"),
				v.cachePatch(itemstring.."INV1"),
				v.cachePatch(itemstring.."EGGM"),
				v.cachePatch(itemstring.."BHOG"),
				v.cachePatch(itemstring.."THNS"),
			})[(stplyr.kartstuff[k_itemroulette]/3) % 13 + 1]
			colorborder = v.getColormap(TC_DEFAULT, SKINCOLOR_NICKEL)
			coloritem = v.getColormap(colormap, stplyr.skincolor)
			v.draw(actualposx, posy, v.cachePatch(itemstring.."BGC"), itemflags, colorborder)
			v.draw(actualposx, posy, table, itemflags, coloritem)
			return
		// Items
		else
			if stplyr.kartstuff[k_itemtype]
				orbi = ((splitscreen >= 2) and "ORBN" or ("ORB"..min(stplyr.kartstuff[k_itemamount], 4)))
			
				//Item table through kartdebugitem order
				table = ({
					v.cachePatch(itemstring.."SHOE"),
					v.cachePatch(itemstring.."RSHE"),
					v.cachePatch(itemstring.."INV"..1+(leveltime/3 % 7)),
					v.cachePatch(itemstring.."BANA"),
					v.cachePatch(itemstring.."EGGM"),
					v.cachePatch(itemstring..orbi),
					v.cachePatch(itemstring.."JAWZ"),
					v.cachePatch(itemstring.."MINE"),
					v.cachePatch(itemstring.."BHOG"),
					v.cachePatch(itemstring.."SPB"),
					v.cachePatch(itemstring.."GROW"),
					v.cachePatch(itemstring.."SHRK"),
					v.cachePatch(itemstring.."THNS"),
					v.cachePatch(itemstring.."HYUD"),
					v.cachePatch(itemstring.."POGO"),
					v.cachePatch(itemstring.."SINK"),
					v.cachePatch(itemstring.."SAD"),
				})[(stplyr.kartstuff[k_itemtype])]
					
				item = table
			end
			//Item blinks
			if stplyr.kartstuff[k_itemblink] > 0 and (leveltime % 2 == 1)
				colormap = TC_BLINK
				blink = ({
					v.getColormap(colormap, SKINCOLOR_WHITE),
					v.getColormap(colormap, SKINCOLOR_RED),
					v.getColormap(colormap, SKINCOLOR_WHITE + (leveltime % (101 - 1))),
				})[(stplyr.kartstuff[k_itemblinkmode]+1)]
			end
			// Color of the boarder
			if (stplyr.kartstuff[k_itemblinkmode] == 0)
				if not splitscreen
					colorborder = v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER)
				else
					colorborder = v.getColormap(TC_DEFAULT, stplyr.skincolor)
				end
			elseif (stplyr.kartstuff[k_itemblinkmode] == 1)
				colorborder = v.getColormap(TC_DEFAULT, SKINCOLOR_CHERRY)
			elseif (stplyr.kartstuff[k_itemblinkmode] == 2)
				colorborder = v.getColormap(TC_DEFAULT, SKINCOLOR_WHITE + ((leveltime/3) % (101 - 1)))
			end
				
			if table
				v.draw(actualposx, posy, v.cachePatch(itemstring.."BGC"), itemflags, colorborder)
				
				if (stplyr.kartstuff[k_itemheld] and (leveltime % 2 == 1))
					item = nothing
				end
					
					
				--draw_itemf(v, stplyr, nothing, table, item)
				
				if not (stplyr.kartstuff[k_stealingtimer] > 0)
					v.draw(actualposx, posy, item, itemflags, blink)
				else
					if (leveltime % 4 <= 2)
						v.draw(actualposx, posy, v.cachePatch(itemstring.."HYUD"), itemflags, colorborder)
					else
						v.draw(actualposx, posy, item, itemflags, blink)
					end
				end
			end
		end
		// Item blinkers
		if not stplyr.kartstuff[k_itemtype]
			local timetable = {
				stplyr.kartstuff[k_stolentimer] > 0,
				stplyr.kartstuff[k_stealingtimer] > 0,
				stplyr.kartstuff[k_eggmanexplode] > 1,
				stplyr.kartstuff[k_rocketsneakertimer] > 1,
				stplyr.kartstuff[k_growshrinktimer] > 0,
				stplyr.kartstuff[k_sadtimer] > 0,
			}
			if timetable
				orbi = ((splitscreen >= 2) and "ORBN" or ("ORB"..min(stplyr.kartstuff[k_itemamount], 4)))
			
				table = ({
					v.cachePatch(itemstring.."SHOE"),
					v.cachePatch(itemstring.."RSHE"),
					v.cachePatch(itemstring.."INV"..1+(leveltime/3 % 7)),
					v.cachePatch(itemstring.."BANA"),
					v.cachePatch(itemstring.."EGGM"),
					v.cachePatch(itemstring..orbi),
					v.cachePatch(itemstring.."JAWZ"),
					v.cachePatch(itemstring.."MINE"),
					v.cachePatch(itemstring.."BHOG"),
					v.cachePatch(itemstring.."SPB"),
					v.cachePatch(itemstring.."GROW"),
					v.cachePatch(itemstring.."SHRK"),
					v.cachePatch(itemstring.."THNS"),
					v.cachePatch(itemstring.."HYUD"),
					v.cachePatch(itemstring.."POGO"),
					v.cachePatch(itemstring.."SINK"),
					v.cachePatch(itemstring.."SAD"),
				})[(stplyr.kartstuff[k_itemtype])]
			
				if splitscreen <= 1
					v.draw(actualposx, posy, v.cachePatch(itemstring.."BGC"), itemflags, colorborder)
				else
					v.draw(actualposx, posy, v.cachePatch(itemstring.."BGC"), itemflags, colorborder)
				end
					
				if timetable[1]
					if (leveltime % 4 <= 2)
						v.draw(actualposx, posy, v.cachePatch(itemstring.."HYUD"), itemflags, colorborder)
					end
				elseif timetable[2] and (leveltime % 4 <= 2)
					if (leveltime % 4 <= 2)
						v.draw(actualposx, posy, v.cachePatch(itemstring.."HYUD"), itemflags, colorborder)
					else
						v.draw(actualposx, posy, item, itemflags, blink)
					end
					--v.draw(actualposx, posy, v.cachePatch(itemstring.."HYUD"), itemflags, colorborder)
				elseif timetable[3]
					if (leveltime % 2 == 1)
						v.draw(actualposx, posy, v.cachePatch(itemstring.."EGGM"), itemflags, colorborder)
					end
				elseif timetable[4]
					if (leveltime % 2 == 1)
						v.draw(actualposx, posy, v.cachePatch(itemstring.."RSHE"), itemflags, colorborder)
					end
				elseif timetable[5]
					if (leveltime % 2 == 1)
						v.draw(actualposx, posy, v.cachePatch(itemstring.."GROW"), itemflags, colorborder)
					end
				elseif timetable[6]
					if (leveltime % 2 == 1)
						v.draw(actualposx, posy, v.cachePatch(itemstring.."SAD"), itemflags, colorborder)
					end
				end
			end
		end
		// Item multiplier
		if (stplyr.kartstuff[k_itemamount] >= minimal and not stplyr.kartstuff[k_itemroulette])
			if splitscreen <= 1
				v.draw(actualposx, posy, v.cachePatch(itemstring.."MUL"), itemflags)
				v.draw(realmulx, multiy, v.cachePatch("K_ITX"), itemflags)
				v.drawKartString(realmulstx, multistringy, stplyr.kartstuff[k_itemamount], itemflags)
			else
				v.draw(realmulx, posy, v.cachePatch(itemstring.."MUL"), mulflip)
				v.drawString(realmulstx, multistringy, "x"..stplyr.kartstuff[k_itemamount], itemflags|V_ALLOWLOWERCASE)
			end
		end
		// Item timer bar
		if stplyr.kartstuff[k_rocketsneakertimer] > 1
			bar = stplyr.kartstuff[k_rocketsneakertimer]
			maxl = (itemtime*3) - barl
		elseif (stplyr.kartstuff[k_growcancel] > 0)
			bar = stplyr.kartstuff[k_growcancel]
			maxl = 26
		end
			
		if bar
			local fill = ((bar*barl)/maxl)
			local length = min(barl, fill)
			local height = (splitscreen > 1 and 1 or 2)
				
			v.draw(realborx, bordery, v.cachePatch(itemstring.."IMER"), itemflags)
			v.drawFill(realfilx, filly, length, height, 12)
			if (length > 2)
				v.drawFill((borderx+length)-stplyr.itemdisscroll, filly, 1, height, 12)
				if (height == 2)
					v.drawFill(realbarx, bary, length, 1, 8)
				end
				v.drawFill(realbarx, filly, length, 1, 1)
			end
		end
		// Fake egg. You're already dead.
		if (stplyr.kartstuff[k_eggmanexplode] > 1)
			v.draw(realfakex, fakey, v.cachePatch("K_EGGN"..min(3, G_TicsToSeconds(stplyr.kartstuff[k_eggmanexplode]))), itemflags) 
		end
	end
end

hud.add(draw_newpositions, game)
hud.add(draw_newtime, game)
hud.add(draw_newgametype, game)
hud.add(draw_newspeedometer, game)
hud.add(draw_newminimap, game)
hud.add(draw_newroulette, game)

hud.disable("freeplay")

addHook("ThinkFrame", do
	for p in players.iterate do	
		-- Load the file in
		if loaded == false
			readFile(p)
			loaded = true
		end
		-- Command Variables
		if dyn_enabled == true
			hud.disable("position")
			hud.disable("time")
			hud.disable("gametypeinfo")
			hud.disable("speedometer")
			hud.disable("minimap")
			hud.disable("item")
		else
			hud.enable("position")
			hud.enable("time")
			hud.enable("gametypeinfo")
			hud.enable("speedometer")
			hud.enable("minimap")
			hud.enable("item")
		end
	end
end)